config/routes.rb
Rails.application.routes.draw do
  resources :books
  resources :assets
  resources :categories
  resources :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root to: 'books#index'
end

app/models/book.rb
class Book < Asset
  include Neo4j::ActiveNode
  property :isbn, type: String
  property :title, type: String
  property :year_published, type: Integer

  has_one :in, :author, type: :CREATED, model_class: :User
  has_many :out, :categories, type: :HAS_CATEGORY

  searchkick index_name: "books_v1"
  def search_data
   {
    id: uuid,
    title: title,
    author: self.author.name,
    email: self.author.email,
    categories: self.categories.collect(&:name),
    year_published: year_published,
    isbn: isbn
    }
  end

end

app/controllers/books_controller.rb
class BooksController < ApplicationController
  before_action :set_book, only: [:show, :edit, :update, :destroy]

  # GET /books
  # GET /books.json
  def index
    if params[:query].present?
      @books = Book.where(title: params[:query]).page(params[:page])
    else
      @books = Book.all.with_associations(:author, :categories).page(params[:page])
    end
    @recommendations = Book.as(:book).
                        categories(:category).
                        books(:other_book).
                        where('book <> other_book').
                        query.
                        with('book, other_book, count(category) AS count').
                        where('count > 1').
                        pluck('book.isbn', 'collect(other_book)')
    @recommendations = Hash[*@recommendations.flatten(1)]
  end

  # GET /books/1
  # GET /books/1.json
  def show
  end

  # GET /books/new
  def new
    @book = Book.new
  end

  # GET /books/1/edit
  def edit
  end

  # POST /books
  # POST /books.json
  def create
    @book = Book.new(book_params)

    respond_to do |format|
      if @book.save
        format.html { redirect_to @book, notice: 'Book was successfully created.' }
        format.json { render :show, status: :created, location: @book }
      else
        format.html { render :new }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /books/1
  # PATCH/PUT /books/1.json
  def update
    respond_to do |format|
      if @book.update(book_params)
        format.html { redirect_to @book, notice: 'Book was successfully updated.' }
        format.json { render :show, status: :ok, location: @book }
      else
        format.html { render :edit }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /books/1
  # DELETE /books/1.json
  def destroy
    @book.destroy
    respond_to do |format|
      format.html { redirect_to books_url, notice: 'Book was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_book
      @book = Book.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    #
    def book_params
        params.require(:book).permit(:isbn, :title, :year_published, :author, :category_ids => [])
    end
end

app/helpers/books_helper.rb
module BooksHelper
end

app/views/books/_form.html.erb
<%= form_for(book) do |f| %>
  <% if book.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(book.errors.count, "error") %> prohibited this book from being saved:</h2>

      <ul>
      <% book.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <label for="isbn"><%= f.label :isbn %></label>
    <%= f.text_field :isbn %>
  </div>

  <div class="form-group">
    <label for="title"><%= f.label :title %></label>
    <%= f.text_field :title %>
  </div>

  <div class="form-group">
    <label for="year_published"><%= f.label :year_published %></label>
    <%= f.number_field :year_published %>
  </div>

  <div class="form-group">
    <label for="author"><%= f.label :author %></label>
    <%= f.select :author, options_from_collection_for_select(User.all, :id, :name, @book.author.try(:id)), include_blank: true %>
  </div>

  <div class="form-group">
    <label for="categories"><%= f.label :categories %></label>
    <%= f.select :category_ids, options_from_collection_for_select(Category.order(:name), :id, :name, @book.categories.map(&:id)), {include_blank: true}, {multiple: true, size: 5} %>
  </div>

  <div class="actions">
    <button type="submit" class="btn btn-default"><%= f.submit %></button>
  </div>
<% end %>

app/views/books/edit.html.erb
<h1>Editing Book</h1>

<%= render 'form', book: @book %>

<%= link_to 'Show', @book, class: 'btn btn-primary' %> |
<%= link_to 'Back', books_path, class: 'btn btn-primary' %>

app/views/books/index.html.erb
<p id="notice"><%= notice %></p>

<h2>Books</h2>
<!-- search form -->
<form action="/books" method="get" class="sidebar-form" style="width:150px;float:right;">
  <div class="input-group">
    <input type="text" name="query" value="<%=@query%>" class="form-control" placeholder="Search Book...">
        <span class="input-group-btn">
          <button type="submit" name="search" id="search-btn" class="btn btn-flat"><i class="fa fa-search"></i>
          </button>
        </span>
  </div>
</form>
<!-- /.search form -->
<table class="table table-bordered">
  <thead>
    <tr>
      <th>Isbn</th>
      <th>Title</th>
      <th>Year published</th>
      <th>Author</th>
      <th>Categories</th>
      <th>Recommendations</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @books.each do |book| %>
      <tr>
        <td><%= book.isbn %></td>
        <td><%= book.title %></td>
        <td><%= book.year_published %></td>
        <td><%= book.author.try(:name) %></td>
        <td>
          <ul>
          <% book.categories.each do |category| %>
            <li><%= link_to category.name, category %></li>
          <% end %>
          </ul>
        </td>
        <td><%= (@recommendations[book.isbn] || []).map(&:title).to_sentence %></td>
        <td><%= link_to 'Show', book %></td>
        <td><%= link_to 'Edit', edit_book_path(book) %></td>
        <td><%= link_to 'Destroy', book, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
    <%= paginate @books %>
    </tbody>
</table>

<br>

<%= link_to 'New Book', new_book_path, class: 'btn btn-primary' %>
<%= link_to 'Back', books_path, class: 'btn btn-primary' if params[:query].present? %>

app/views/books/new.html.erb
<h1>New Book</h1>

<%= render 'form', book: @book %>

<%= link_to 'Back', books_path, class: 'btn btn-primary' %>

app/views/books/show.html.erb
<p id="notice"><%= notice %></p>

<table class="table table-bordered">
  <tbody>
      <tr>
        <th>Isbn</th>
        <td><%= @book.isbn %></td>
      </tr>
      <tr>
        <th>Title</th>
        <td><%= @book.title %></td>
      </tr>
      <tr>
        <th>Year published</th>
        <td><%= @book.year_published %></td>
      </tr>
      <tr>
        <th>Author</th>
        <td><%= @book.author %></td>
      </tr>
      <tr>
        <th>Categories</th>
        <td><%= @book.categories.map(&:name).to_sentence %></td>
      </tr>
  </tbody>
</table>

<%= link_to 'Edit', edit_book_path(@book), class: 'btn btn-primary' %> |
<%= link_to 'Back', books_path, class: 'btn btn-primary' %>